---
title: 简历 · 陈不渡 Mozzie
layout: cosy-resume
avatar: /img/avatar.jpg
name: Hi!
role: Full Stack
email: himozzie@gmail.com
phone: +86 180-xxxx-xxx
birth: Jan 21, 1994
location: Nanjing, China
social:
  - name: github
    link: https://github.com/17px
    icon: <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 24 24"><path d="M9 19c-4.3 1.4-4.3-2.5-6-3m12 5v-3.5c0-1 .1-1.4-.5-2c2.8-.3 5.5-1.4 5.5-6a4.6 4.6 0 0 0-1.3-3.2a4.2 4.2 0 0 0-.1-3.2s-1.1-.3-3.5 1.3a12.3 12.3 0 0 0-6.2 0C6.5 2.8 5.4 3.1 5.4 3.1a4.2 4.2 0 0 0-.1 3.2A4.6 4.6 0 0 0 4 9.5c0 4.6 2.7 5.7 5.5 6c-.6.6-.6 1.2-.5 2V21" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"></path></svg>
about:
  - 熟练掌握Vue和React全家桶，包括状态管理和组件库，如ElementPlus 和 AntDesign。在前端工程化方面，有 Webpack 和 Vite 的配置经验。具备 SpringBoot、Egg、Koa2 和 Midway 的项目经验，并在微服务架构下使用 Nestjs。熟悉Linux基础命令和Nginx、Docker的使用。
  - 在3D图形和医疗前端方面，具有 three.js 和 Vtk.js 的实践经验

skill:
  - 熟悉常见的数据结构和算法，熟悉设计模式
  - 熟悉前端基础 HTML5、CSS3、JS、ES6+、TypeScript 语法
  - 熟悉 Vue2、Vue3 全家桶，熟悉 ElementPlus、NaiveUI，熟悉 Vue 原理
  - 熟悉 React 技术栈，熟悉 Hooks 语法，熟悉 AntDesign，熟悉 React 原理
  - 熟悉微信小程序开发，熟悉 Taro 框架的使用
  - 熟悉 Webpack、Vite 常见配置，以及性能优化配置
  - 熟悉 Node，具备后端开发能力，SpringBoot、Egg、Koa2、Midway 单体应用项目经验，Nestjs 微服务应用项目经验
  - 有 Monorepo 工程化经验，具备单体前后端分离应用 DevOps 能力
  - 熟悉 three.js、了解 Vtk.js，具备医疗 3D 前端、图形学相关的开发经验
  - 掌握 Linux 基本命令，了解 Nginx、Docker 基本使用

education:
  - school: 南京信息工程大学滨江学院 / 本科
    time: 2012-2016

workExp:
  - inc: 拓微摹心数据科技(南京)有限公司 · 全栈
    time: 2021.09 ~ 至今
  - inc: 南京寻鹿网络科技有限公司 · 前端
    time: 2016.09 ~ 2019.06

projectExp:
  - name: CVPilot算法、标注数据中台
    desc: 具备高精度数据标注、强大的数据管理、算法集成、多级用户权限、标注流程协作、算法模型版本、训练测试、API接口和数据可视化等功能，全面支持公司内部医疗影像分析和诊断
    list:
      - 使用 Pnpm workspace 实现 Monorepo 多个代码仓库管理，支持多个框架并存，可共享公共组件库和能力
      - 自行使用 rollup 沉淀了部分可复用基础模块，如：UI 组件库、对象存储、邮件、短信、企业微信机器人通知
      - 使用 Nest.js 开发，基于事件驱动架构，重构后端服务体系
      - 基于 rbac 设计了认证中心，解决业务应用中用户统一授权、鉴权的问题
      - 使用 orthanc 搭建 Pacs 影像、并且基于标注、业务流程设计了影像上层的标签系统
      - 使用 pdf.js 实现 3Mensio、FluoroCT 医疗报告关键字段的自动解析，Cover了 80%+ 的字段
      - 设计了前后端一体开发的领域驱动设计（DDD）项目架构，并成功实践

  - name: TAVR手术辅助决策系统 Tavigator™
    desc: 系统实现了对CT影像主动脉根部解剖结构的全自动化、全流程手术规划测量，为瓣膜选型、术中并发症风险预测
    list:
      - 基于容器，解决算法输出 stl 模型增加血管壁厚等后处理需求
      - 在 OHIF 基础上，重新规划项目结构，工程化相关优化，构建速度提升8倍
      - 对 orthanc 配置进行了优化，使用 postgreSQL 存储影像数据
      - 实践了 threejs 替换了 vtk.js 的默认三维渲染引擎，节省了某些场景下 Vtk.js占用内存过大的问题
      - 使用了 chrome的 snapshot、调用栈，优化页面内存 3GB+，使用 Indexdb 与 Webworker 对 Dicom 读片速度优化了3倍以上
      - 使用 webworker、请求队列，实现了在 http1.1 环境下，提升用户上传 Dicom影像 74% 上传效率。同时针对不同大小、类型的文件，设计了不同的 Hash 切片方案，提升了文件完整性验证速度提升
      - 使用了 Http3 和 nginx-quic，使用 Brotli 替换 gzip，实现了静载资源传输速度提升 17% - 25%

  - name: Bolt 组件库、文档设计系统
    desc: 前端基建，Bolt 用于构建快速组件库、文档。你可以在开发react组件库的同时, 无缝地编写组件文档, 实时热更新
    list:
      - React 组件的 Props 解析，自动生成组件的 API 表格
      - 组件的开发阶段，实施更新，所见即所得
      - 依赖 vite 插件机制，200+ 以上组件，开发阶段秒级热更新
      - 智能生成组件说明文档，构建产物分离组件库、文档静态站，支持全局、局部引入

  - name: 瓣侣 - 微信小程序
    desc: 一款支持医生、病人查看算法分割后数字孪生心脏模型的小程序
    list:
      - 使用 taro 对小程序端实现3d模型展示，进行了技术选型，移植了STLloader 到 three-platformize 中，解决了 stl 模型加载的问题
      - 解决小程序内存占用过大，导致部分机型崩溃的问题
      - 使用包围盒对多个分割模型组合及位置修正、空间测量计算，实现瓣环样条绘制、空间拾取高亮等功能

portfolio:
  - name: CVPilot (原Tavigator)
    desc: 基于深度学习测量、分割的 TAVI 手术辅助决策系统
    iconSVG: <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 32 32"><path d="M21 10h-4V6h-2v4h-4v2h4v4h2v-4h4v-2z" fill="currentColor"></path><path d="M28 10h-2V4a2.002 2.002 0 0 0-2-2H8a2.002 2.002 0 0 0-2 2v6H4a2.002 2.002 0 0 0-2 2v18h28V12a2.002 2.002 0 0 0-2-2zM14 28v-6h4v6zm6 0v-7a1 1 0 0 0-1-1h-6a1 1 0 0 0-1 1v7H4V12h4V4h16v8h4v16z" fill="currentColor"></path></svg>
    link: https://www.tavi.fit

  - name: Bolt Design
    desc: 基于 Vite 开发的 React 组件、文档一体化系统
    iconSVG: <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 24 24"><g fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M6.357 9C3.72 9.68 2 10.845 2 12.175C2 14.282 6.405 16 11.85 16c.74 0 1.26-.039 1.95-.097"></path><path d="M9.837 15.9c-.413-.596-.806-1.133-1.18-1.8c-2.751-4.9-3.488-9.77-1.63-10.873c1.15-.697 3.047.253 4.974 2.254"></path><path d="M6.429 15.387c-.702 2.688-.56 4.716.56 5.395c1.783 1.08 5.387-1.958 8.043-6.804c.36-.67.683-1.329.968-1.978"></path><path d="M12 18.52c1.928 2 3.817 2.95 4.978 2.253c1.85-1.102 1.121-5.972-1.633-10.873c-.384-.677-.777-1.204-1.18-1.8"></path><path d="M17.66 15c2.612-.687 4.34-1.85 4.34-3.176C22 9.714 17.592 8 12.155 8c-.747 0-1.266.029-1.955.087"></path><path d="M8 12c.285-.66.607-1.308.968-1.978c2.647-4.844 6.253-7.89 8.046-6.801c1.11.679 1.262 2.706.56 5.393"></path><path d="M12.26 12.015h-.01c-.01.13-.12.24-.26.24a.263.263 0 0 1-.25-.26c0-.14.11-.25.24-.25h-.01c.13-.01.25.11.25.24"></path></g></svg>
    link: https://amo.mozzie.cn/

  - name: hexo-theme-cosy
    desc: 极简主义，追求Hexo主题的终极加载速度
    iconSVG: <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 24 24"><path d="M9 19c-4.3 1.4-4.3-2.5-6-3m12 5v-3.5c0-1 .1-1.4-.5-2c2.8-.3 5.5-1.4 5.5-6a4.6 4.6 0 0 0-1.3-3.2a4.2 4.2 0 0 0-.1-3.2s-1.1-.3-3.5 1.3a12.3 12.3 0 0 0-6.2 0C6.5 2.8 5.4 3.1 5.4 3.1a4.2 4.2 0 0 0-.1 3.2A4.6 4.6 0 0 0 4 9.5c0 4.6 2.7 5.7 5.5 6c-.6.6-.6 1.2-.5 2V21" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"></path></svg>
    link: https://github.com/17px/hexo-theme-cosy
---
